package compiler

import (
	"git.akyoto.dev/cli/q/src/arch/x64"
	"git.akyoto.dev/cli/q/src/asm"
	"git.akyoto.dev/cli/q/src/os/linux"
)

// Finalize generates the final machine code.
func Finalize(functions map[string]*Function) ([]byte, []byte) {
	a := asm.New()

	for _, f := range functions {
		a.Merge(&f.Assembler)
	}

	a.MoveRegisterNumber(x64.SyscallNumber, linux.Exit)
	a.MoveRegisterNumber(x64.SyscallArgs[0], 0)
	a.Syscall()

	code, data := a.Finalize()
	return code, data
}
