package compiler

import (
	"git.akyoto.dev/cli/q/src/arch/x64"
	"git.akyoto.dev/cli/q/src/asm"
	"git.akyoto.dev/cli/q/src/os/linux"
	"git.akyoto.dev/cli/q/src/token"
)

// Function represents a function.
type Function struct {
	Name      string
	Head      token.List
	Body      token.List
	Assembler asm.Assembler
}

// Compile turns a function into machine code.
func (f *Function) Compile() {
	for i, t := range f.Body {
		if t.Kind == token.Identifier && t.Text() == "print" {
			message := f.Body[i+2].Bytes
			f.Assembler.MoveRegisterNumber(x64.SyscallNumber, linux.Write)
			f.Assembler.MoveRegisterNumber(x64.SyscallArgs[0], 1)
			f.Assembler.MoveRegisterData(x64.SyscallArgs[1], message)
			f.Assembler.MoveRegisterNumber(x64.SyscallArgs[2], uint64(len(message)))
			f.Assembler.Syscall()
		}
	}
}

// String returns the function name.
func (f *Function) String() string {
	return f.Name
}
