package errors

import "fmt"

// RegisterInUse errors are returned when a register is already in use.
type RegisterInUse struct {
	Register string
	User     string
}

// Error implements the text representation.
func (err *RegisterInUse) Error() string {
	return fmt.Sprintf("Register '%s' already used by '%s'", err.Register, err.User)
}
